#!/usr/bin/python

# Quirky21.py by Moe Aboulkheir
# I bashed this out because suse doesnt ship with any blackjack games
# its still very beta

from Tkinter      import *
from tkMessageBox import *

import random, os, string, sys, time, glob, thread

class Table( Frame ):

	def __init__( self, parent=None, decks=5 ):

		Frame.__init__( self, parent )

		self.ImageFolders={ "S" : ["images", "cards", "spades"],
				                "C" : ["images", "cards", "clubs" ],
				                "H" : ["images", "cards", "hearts"],
				                "D" : ["images", "cards", "diamonds"] }
                        
		for key in self.ImageFolders:
			self.ImageFolders[key]=string.join(self.ImageFolders[key], os.sep) + os.sep

		self.CardSeq= "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "jack", "queen", "king"

		self.ValueMap= { "jack"  : 10,
				             "queen" : 10,
				             "king"  : 10  }

		self.DecksInShoe=int(decks)

		self.Money      = 5000
		self.Minimum    = 10
		self.Maximum    = 100
		self.ThisBet    = 0
		self.PlayerX    = 320
		self.PlayerY    = 350
		self.PSplitX    = 620
		self.PSplitY    = 350
		self.DealerX    = 470
		self.DealerY    = 20
		self.Player     = 0
		self.Dealer     = 0

		self.SmallNumberImages=[]
		self.ImagesToKill     =[]
		self.CardImageDict    ={}
		self.ImageDict       ={}

		self.StatusDict={ "Player" : {},
				              "Dealer" : {},
				              "Game"   : {}  }

		for Suit, Folder in self.ImageFolders.items():
			for Card in self.CardSeq:
				self.CardImageDict[ Suit + Card ]=PhotoImage(file=Folder + Card + ".gif")

		self.DrawTable()
		self.MakeShoe ()
		self.Setup    ()
		self.GetBet   ()
		self.pack     ()

	def DrawTable( self ):
		self.Table  =  Canvas(width=900, height=700)
		self.Table.pack()
		self.FeltImg=  PhotoImage(file="images" + os.sep + "other" + os.sep + "felt.gif")
		Felt   =  self.Table.create_image( 0,  0,  image=self.FeltImg, anchor=NW )

	def MakeShoe( self ):
		StartOrder=[]
		self.Shoe =[]
		self.CardCount=0
		for DeckNum in range( self.DecksInShoe ):
			for Suit in self.ImageFolders:
				for Card in self.CardSeq:
					self.CardCount+=1
					self.Shoe.append( Suit + Card )
		self.Shuffle()


	def Shuffle( self ):
		ShuffledDeck=[]
		while self.Shoe:
			ShuffledDeck.append( self.Shoe.pop( random.randint( 0, ( len(self.Shoe) - 1 ) ) ) )

		self.Shoe = ShuffledDeck


	def Setup( self ):

		for ImageFileName in glob.glob("images" + os.sep + "other" + os.sep + "*"):
			OurName= os.path.splitext( os.path.split( ImageFileName )[-1] )[0]
			self.ImageDict[ OurName ] =PhotoImage(file=ImageFileName)

		self.Table.create_image( 20,  20,  image=self.ImageDict["back"],    anchor=NW)
		self.Table.create_image( 700, 20,  image=self.ImageDict["back"],    anchor=NW)
		self.Table.create_image( 10,  500, image=self.ImageDict["thisbet"], anchor=NW)
		self.Table.create_image( 400, 645, image=self.ImageDict["dollar"],  anchor=NW)
		self.Table.create_image( 150, 490, image=self.ImageDict["dollar"],  anchor=NW)
		self.Table.create_image( 10,  410, image=self.ImageDict["player"],  anchor=NW)
		self.Table.create_image( 10,  350, image=self.ImageDict["house"],   anchor=NW)

		self.HitMe =self.Table.create_image( 310, 590, image=self.ImageDict["hitme"],  anchor=NW)
		self.Stay  =self.Table.create_image( 440, 590, image=self.ImageDict["stay"],   anchor=NW)
		self.Double=self.Table.create_image( 540, 590, image=self.ImageDict["double"], anchor=NW)

		self.Table.create_image( 10,  250, image=self.ImageDict["cardsleft"],  anchor=NW)
		self.Table.create_image( 700, 250, image=self.ImageDict["cardsdealt"], anchor=NW)

		for Num in range(10):
			SmallImage=PhotoImage( file= "images" + os.sep + "small_numbers" + os.sep + "%d.gif" % Num )
			self.SmallNumberImages.append( SmallImage )

		self.StatusPosDict={ "Dealer" : (170, 350),
				                 "Player" : (170, 405),
				                 "Game"   : (20 , 600) }

		self.StatusImgDict={ "Soft"      : self.ImageDict["soft"],
				                 "Bust"      : self.ImageDict["bust"],
				                 "Blackjack" : self.ImageDict["blackjack"],
				                 "Standoff"  : self.ImageDict["standoff"],
				                 "PlayerWins": self.ImageDict["playerwins"],
				                 "DealerWins": self.ImageDict["housewins"]   }

		self.NumPosDict={ "CardsLeft" : (90 , 250),
				              "CardsDealt": (800, 250),
				              "MoneyLeft" : (435, 650),
				              "BetAmount" : (180, 490),
				              "PlayerIsAt": (100, 405),
				              "DealerIsAt": (100, 350)  }

		self.NumSrcDict={ "CardsLeft" : "len(self.Shoe)",
				              "CardsDealt": "self.CardCount - len(self.Shoe)",
				              "MoneyLeft" : "self.Money",
				              "BetAmount" : "self.ThisBet",
				              "PlayerIsAt": "self.Player",
				              "DealerIsAt": "self.Dealer"  }

		self.UsedNumImgs={}

		for Key in self.NumPosDict:
			self.UsedNumImgs  [ Key ]=[]
			self.UpdateNumbers( Key )


	def UpdateNumbers( self, Purpose ):
		X, Y= self.NumPosDict[ Purpose ]
		for Img in self.UsedNumImgs[ Purpose ]:
			self.Table.delete( Img )

		NumStr= str( eval( self.NumSrcDict[ Purpose ] ) )

		for Num in list( NumStr ):
			OurNumImg= self.SmallNumberImages[ int(Num) ]
			PutNumImg= self.Table.create_image( X, Y, image=OurNumImg, anchor=NW )
			self.UsedNumImgs[ Purpose ].append( PutNumImg )
			self.update()
			X+= 30

	def GetCardValue(self, Card):
		return int( self.ValueMap.get( Card[1:], Card[1:] ) )

	def PutCard( self, X, Y ):
		try:
			Card=self.Shoe.pop()
		except:
			sys.exit("round over")

		self.UpdateNumbers("CardsDealt")
		self.UpdateNumbers("CardsLeft" )
		NumericValue= self.GetCardValue ( Card )
		Image= self.CardImageDict[ Card ]
		CardImage=self.Table.create_image(X, Y, image=Image, anchor=NW )
		self.ImagesToKill.append( CardImage )
		self.update()
		return NumericValue

	def DealDealer( self, UntilEnd=False, PlayerBlackJack=0 ):
		self.UnbindEverything()
		time.sleep(1)
		Y= self.DealerY + self.DealerOffsetY
		self.DealerCards   += 1
		NumericValue= self.PutCard( self.DealerX, Y )
		self.DealerOffsetY += 50

		if PlayerBlackJack==1:
			if self.Dealer == 11 or self.Dealer==10:
			 	self.DealDealer(PlayerBlackJack=2)
			else:
				self.Money+= int(self.ThisBet * 2.5)
				self.EndGame()
				return
		elif PlayerBlackJack==2:
			if self.Dealer==21:
				self.SetStatus("Dealer", "Blackjack")
				self.SetStatus("Game", "Standoff")
			else:
				self.Money+= int(self.ThisBet * 2.5)
				self.EndGame()
				return

		if NumericValue==1:
			if   ( self.Dealer + 11 ) >  21:
				self.Dealer += 1
			elif ( self.Dealer + 11 ) == 21:
				self.Dealer += 11
				self.SetStatus("Dealer", "Soft", remove=1)
				self.SoftDealer=0
			else:
				self.SoftDealer  = 1
				self.Dealer     += 11
				self.SetStatus("Dealer", "Soft")
		else:
			self.Dealer+=NumericValue

		self.UpdateNumbers("DealerIsAt")

		if self.Dealer > 21:
			if self.SoftDealer:
				self.SoftDealer=0
				self.SetStatus("Dealer", "Soft", remove=1)
				self.Dealer-=10
				self.UpdateNumbers("DealerIsAt")
			else:
				BustedImg=self.Table.create_image(self.DealerX, Y, image=self.ImageDict["zap"], anchor=NW)
				self.ImagesToKill.append( BustedImg )
				self.update()
				self.SetStatus("Dealer", "Bust")
				self.SetStatus("Game", "PlayerWins")
				self.Money+=self.ThisBet * 2
				self.EndGame()
				return

		elif self.Dealer == 21:
			if self.DealerCards==2:
				self.SetStatus("Dealer", "Blackjack")

		if self.Dealer < 17:
			if UntilEnd:
				self.DealDealer( UntilEnd= True )
		else:
			if self.Dealer > self.Player:
				self.SetStatus("Game", "DealerWins" )
			elif self.Dealer < self.Player:
				self.Money+=self.ThisBet * 2
				self.SetStatus("Game", "PlayerWins")
			else:
				self.SetStatus("Game", "Standoff")
				self.Money+=self.ThisBet
			self.EndGame()

	def UnbindEverything( self ):
		self.Table.tag_unbind(self.HitMe, "<Button-1>")
		self.Table.tag_unbind(self.Double,"<Button-1>")
		self.Table.tag_unbind(self.Stay,  "<Button-1>")

	def BindEverything( self ):
		self.Table.tag_bind( self.HitMe, "<Button-1>", self.DealPlayer  )
		self.Table.tag_bind( self.Stay,  "<Button-1>", self.PlayerDone  )
		self.Table.tag_bind( self.Double,"<Button-1>", self.DoubleHand  )

	def PlayerDone( self, event=None ):
		self.UnbindEverything()
		self.DealDealer( UntilEnd=True )

	def DealPlayer( self, event=None ):
		self.UnbindEverything()
		X, Y=self.PlayerX, self.PlayerY - self.PlayerOffsetY
		NumericValue= self.PutCard( X, Y )
		self.PlayerCards+=1
		self.PlayerOffsetY += 50
		self.update()

		if NumericValue==1:
			if ( self.Player + 11 ) > 21:
				self.Player+=1
			else:
				self.Player+=11
				self.UpdateNumbers("PlayerIsAt")
				self.SoftPlayer=1
				self.SetStatus("Player", "Soft")
		else:
			self.Player+=NumericValue

		self.UpdateNumbers("PlayerIsAt")

		if self.Player > 21:
			if self.SoftPlayer:
				self.SoftPlayer=0
				self.SetStatus("Player", "Soft", remove=1)
				self.Player-=10
				self.UpdateNumbers("PlayerIsAt")
			else:
				BustedImg=self.Table.create_image(self.PlayerX, Y, image=self.ImageDict["zap"], anchor=NW)
				self.ImagesToKill.append( BustedImg )
				self.update()
				self.SetStatus("Player", "Bust")
				self.SetStatus("Game", "DealerWins")
				self.EndGame()

		elif self.Player == 21:
			self.SetStatus("Player", "Soft", remove=1)
			if self.PlayerCards==2:
				self.UnbindEverything()
				self.SetStatus("Player", "Blackjack")
				self.DealDealer(PlayerBlackJack=1)

		self.UpdateNumbers("PlayerIsAt")
		self.UpdateNumbers("CardsDealt")
		self.UpdateNumbers("CardsLeft" )
		self.PrevCard=NumericValue
		self.BindEverything()

	def DoubleHand( self, event ):
		if self.PlayerCards==2 and self.Player==8 or self.Player==9 or self.Player==11:
			self.UnbindEverything()
			self.Money -= self.ThisBet
			self.ThisBet *= 2
			self.UpdateNumbers("BetAmount")
			self.UpdateNumbers("MoneyLeft")
			time.sleep(1)
			self.DealPlayer()
			self.PlayerDone()
		else:
			showerror("Quirky21", "You can only double if the first two cards of your hand total 8, 9 or 11")

	def EndGame( self ):
		self.UnbindEverything()
		time.sleep(4)
		for Img in self.ImagesToKill:
			self.Table.delete( Img )
		self.UpdateNumbers("MoneyLeft")
		self.ThisBet=0
		self.UpdateNumbers("BetAmount")
		self.Dealer=0
		self.Player=0
		self.UpdateNumbers("PlayerIsAt")
		self.UpdateNumbers("DealerIsAt")
		self.GetBet()

	def DealCards( self ):
		self.Money-=self.ThisBet
		self.UpdateNumbers("MoneyLeft")
		self.PlayerBJ     =0
		self.DealerBJ     =0
		self.SoftPlayer   =0
		self.SoftDealer   =0
		self.PlayerCards  =0
		self.DealerCards  =0
		self.Dealer       =0
		self.Player       =0
		self.DealerOffsetX=0
		self.DealerOffsetY=0
		self.PlayerOffsetX=0
		self.PlayerOffsetY=0

		self.DealPlayer()
		self.DealDealer()

		self.BindEverything()


	def SetStatus(self, Player, Status, remove=0 ):
		if remove:
			try:
				self.Table.delete( self.StatusDict[Player][Status] )
				self.update()
			except KeyError:
				pass
			return

		X, Y= self.StatusPosDict[ Player ]

		self.StatusDict[Player][Status]= self.Table.create_image( X, Y, image=self.StatusImgDict[ Status ], anchor=NW)
		self.ImagesToKill.append( self.StatusDict[Player][Status] )
		self.update()

	def GetBetVal( self, event ):
		try:
			BetAmount= int( self.AmountEntry.get() )
			self.AskBet.destroy()
			if self.Minimum <= BetAmount <= self.Maximum:
				self.ThisBet=BetAmount
				self.UpdateNumbers("BetAmount")
				self.UpdateNumbers("MoneyLeft")
				self.DealCards()
			else:
				raise ValueError

		except ValueError:
			self.AmountEntry.destroy()
			showerror("Quirky21", "Minimum bet is %d, maximum bet is %d" % ( self.Minimum, self.Maximum ) )
			self.GetBet()

	def GetBet( self ):
		self.AskBet= Toplevel(width=50, height=50)
		Label(self.AskBet,  text="Enter Bet For This Hand").pack(padx=10, pady=10)
		self.AmountEntry= Entry(self.AskBet)
		self.AmountEntry.pack(padx=10, pady=10)
		self.AskBet.bind( "<Return>", self.GetBetVal )
		self.AmountEntry.focus()
		self.AskBet.focus_set()
		self.AskBet.grab_set()
		self.AskBet.wait_window()

RootWin=Tk()
try:
	DiS= sys.argv[1]
except:
	DiS=5

RootWin.title("Quirky 21")
RootWin.maxsize( 900, 700 )
MyTable= Table( RootWin, DiS )
RootWin.mainloop()
